# Generated by Django 3.1.7 on 2021-07-15 07:48

from django.db import migrations, models
import django.db.models.deletion


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        ('service_catalog', '0003_auto_20210518_1513'),
    ]

    operations = [
        migrations.CreateModel(
            name='Resource',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(max_length=100, unique=True)),
            ],
        ),
        migrations.CreateModel(
            name='ResourceGroup',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(max_length=100, unique=True)),
            ],
        ),
        migrations.CreateModel(
            name='ResourcePool',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(max_length=100, unique=True)),
            ],
        ),
        migrations.CreateModel(
            name='ResourcePoolAttributeDefinition',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(max_length=100)),
                ('resource_pool', models.ForeignKey(null=True, on_delete=django.db.models.deletion.PROTECT, related_name='attribute_definitions', related_query_name='attribute_definition', to='resource_tracker.resourcepool')),
            ],
            options={
                'unique_together': {('name', 'resource_pool')},
            },
        ),
        migrations.CreateModel(
            name='ResourceGroupAttributeDefinition',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(max_length=100)),
                ('consume_from', models.ForeignKey(null=True, on_delete=django.db.models.deletion.PROTECT, related_name='consumers', related_query_name='consumer', to='resource_tracker.resourcepoolattributedefinition')),
                ('produce_for', models.ForeignKey(null=True, on_delete=django.db.models.deletion.PROTECT, related_name='producers', related_query_name='producer', to='resource_tracker.resourcepoolattributedefinition')),
                ('resource_group_definition', models.ForeignKey(null=True, on_delete=django.db.models.deletion.PROTECT, related_name='attribute_definitions', related_query_name='attribute_definition', to='resource_tracker.resourcegroup')),
            ],
            options={
                'unique_together': {('name', 'resource_group_definition')},
            },
        ),
        migrations.CreateModel(
            name='ResourceAttribute',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('value', models.PositiveIntegerField(default=0)),
                ('attribute_type', models.ForeignKey(null=True, on_delete=django.db.models.deletion.CASCADE, related_name='attribute_types', related_query_name='attribute_type', to='resource_tracker.resourcegroupattributedefinition')),
                ('resource', models.ForeignKey(null=True, on_delete=django.db.models.deletion.CASCADE, related_name='attributes', related_query_name='attribute', to='resource_tracker.resource')),
            ],
        ),
        migrations.AddField(
            model_name='resource',
            name='resource_group',
            field=models.ForeignKey(null=True, on_delete=django.db.models.deletion.SET_NULL, related_name='resources', related_query_name='resource', to='resource_tracker.resourcegroup'),
        ),
        migrations.AddField(
            model_name='resource',
            name='service_catalog_instance',
            field=models.ForeignKey(null=True, on_delete=django.db.models.deletion.SET_NULL, related_name='service_catalog_instances', related_query_name='service_catalog_instance', to='service_catalog.instance'),
        ),
    ]
